//-----------------------------------------------------------------------------
//
// Title       : phase2a_tf
// Design      : lab4
// Author      : Steven
// Company     : University of Washington CSE
//
//-----------------------------------------------------------------------------
//
// File        : phase2a_tf.v
// Generated   : Wed Nov  8 17:07:06 2006
// From        : E:\my_designs\AndrewH\lab4\src\Tests\phase2a_tf_settings.txt
// By          : tb_verilog.pl ver. ver 1.2s
//
//-----------------------------------------------------------------------------
//
// Description : 
//
//-----------------------------------------------------------------------------

`timescale 1ps / 1ps
module phase2a_tf;


//Internal signals declarations:
reg [25:16]ID_Inst;
reg ID_JR;
reg ID_Branch;
reg EX_RegWrite;
reg EX_Load;
reg [4:0]EX_WriteReg;
reg MEM_RegWrite;
reg MEM_Load;
reg [4:0]MEM_WriteReg;
wire IDEXReg_Clear_actual;
reg IDEXReg_Clear;
wire LoadEnable_actual;
reg LoadEnable;
//LOG file declaration.
integer report_file;

//Wait time declaration used in ports monitoring.
//One parameter is declared for every port.
parameter Default_wait_time = 10;
parameter IDEXReg_Clear_WaitTime = Default_wait_time;//WaitTime Parameter for port IDEXReg_Clear
parameter LoadEnable_WaitTime = Default_wait_time;//WaitTime Parameter for port LoadEnable

//Simulation time
parameter SimulationTime = 64'd3904000 + Default_wait_time + 1;

//Errors counter
integer errors_counter;

//Block of Comparison functions declarations. A separate function for each output port is defined.
//Comparison function for port "IDEXReg_Clear"
function compare_IDEXReg_Clear;
input  UUT_output;
input  PATTERN;
	begin
		if (UUT_output !== PATTERN) compare_IDEXReg_Clear = 1'b1;
		else compare_IDEXReg_Clear = 1'b0;
	end
endfunction
//Comparison function for port "LoadEnable"
function compare_LoadEnable;
input  UUT_output;
input  PATTERN;
	begin
		if (UUT_output !== PATTERN) compare_LoadEnable = 1'b1;
		else compare_LoadEnable = 1'b0;
	end
endfunction

// Unit Under Test port map
	HazardDetectionUnit UUT (
		.ID_Inst(ID_Inst),
		.ID_JR(ID_JR),
		.ID_Branch(ID_Branch),
		.EX_RegWrite(EX_RegWrite),
		.EX_Load(EX_Load),
		.EX_WriteReg(EX_WriteReg),
		.MEM_RegWrite(MEM_RegWrite),
		.MEM_Load(MEM_Load),
		.MEM_WriteReg(MEM_WriteReg),
		.IDEXReg_Clear(IDEXReg_Clear_actual),
		.LoadEnable(LoadEnable_actual));

initial
	begin
		report_file=$fopen("$DSN\\src\\Tests\\compare_report.log");
		errors_counter = 0;
		#SimulationTime;
		if (errors_counter)
		begin
			$display("Errors were encountered, differences are listed in compare_report.log");
			$fdisplay(report_file,"Some vectors failed.");
		end
		else
		begin
			$display("All vectors passed.");
			$fdisplay(report_file,"All vectors passed.");
		end
		$fclose(report_file);
		$finish;
	end

//Below code was generated based on waveform file: "E:\my_designs\AndrewH\lab4\compile\hazard.vhr"

initial
begin : STIMUL // begin of stimulus process
	#0
	ID_JR = 1'bx;
	ID_Branch = 1'bx;
	EX_RegWrite = 1'bx;
	ID_Inst = 10'bXXXXXXXXXX;
	EX_Load = 1'bx;
	MEM_Load = 1'bx;
	EX_WriteReg = 5'bXXXXX;
	IDEXReg_Clear = 1'bx;
	LoadEnable = 1'bx;
	MEM_WriteReg = 5'bXXXXX;
	MEM_RegWrite = 1'bx;
    #165000; //0
	ID_JR = 1'b0;
	ID_Branch = 1'b0;
	EX_RegWrite = 1'b0;
	ID_Inst = 10'b0000000000;
	EX_Load = 1'b0;
	MEM_Load = 1'b0;
	EX_WriteReg = 5'b00000;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //165000
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0000000001;
    #20000; //185000
	ID_Inst = 10'b0000101001;
	EX_WriteReg = 5'b00001;
	MEM_RegWrite = 1'b1;
    #20000; //205000
	ID_Inst = 10'b0000000001;
	EX_WriteReg = 5'b01001;
	MEM_WriteReg = 5'b00001;
    #20000; //225000
	ID_Inst = 10'b0000101010;
	EX_WriteReg = 5'b00001;
	MEM_WriteReg = 5'b01001;
    #20000; //245000
	ID_Inst = 10'b0000000001;
	EX_WriteReg = 5'b01010;
	MEM_WriteReg = 5'b00001;
    #20000; //265000
	ID_Inst = 10'b0000101011;
	EX_WriteReg = 5'b00001;
	MEM_WriteReg = 5'b01010;
    #20000; //285000
	ID_Inst = 10'b0000000001;
	EX_WriteReg = 5'b01011;
	MEM_WriteReg = 5'b00001;
    #20000; //305000
	ID_Inst = 10'b0000101101;
	EX_WriteReg = 5'b00001;
	MEM_WriteReg = 5'b01011;
    #20000; //325000
	ID_Inst = 10'b0000011101;
	EX_WriteReg = 5'b01101;
	MEM_WriteReg = 5'b00001;
    #20000; //345000
	ID_Inst = 10'b0000000000;
	EX_WriteReg = 5'b11101;
	MEM_WriteReg = 5'b01101;
    #20000; //365000
	ID_Branch = 1'b1;
	ID_Inst = 10'b0001000000;
	EX_WriteReg = 5'b00010;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
	MEM_WriteReg = 5'b11101;
    #20000; //385000
	EX_RegWrite = 1'b0;
	EX_WriteReg = 5'b00000;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
	MEM_WriteReg = 5'b00010;
    #20000; //405000
	ID_Branch = 1'b0;
	ID_Inst = 10'b0000000000;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //425000
	ID_Branch = 1'b1;
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0000000011;
	EX_WriteReg = 5'b00011;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
    #20000; //445000
	EX_RegWrite = 1'b0;
	EX_WriteReg = 5'b00000;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
	MEM_WriteReg = 5'b00011;
	MEM_RegWrite = 1'b1;
    #20000; //465000
	ID_Branch = 1'b0;
	ID_Inst = 10'b0000011101;
	EX_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //485000
	ID_Branch = 1'b1;
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0001000000;
	EX_WriteReg = 5'b00010;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
	MEM_WriteReg = 5'b00011;
    #20000; //505000
	EX_RegWrite = 1'b0;
	EX_WriteReg = 5'b00000;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
	MEM_WriteReg = 5'b00010;
	MEM_RegWrite = 1'b1;
    #20000; //525000
	ID_Branch = 1'b0;
	ID_Inst = 10'b0000011101;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //545000
	ID_Branch = 1'b1;
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0000000011;
	EX_WriteReg = 5'b00011;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
    #20000; //565000
	EX_RegWrite = 1'b0;
	EX_WriteReg = 5'b00000;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
	MEM_WriteReg = 5'b00011;
	MEM_RegWrite = 1'b1;
    #20000; //585000
	ID_Branch = 1'b0;
	EX_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //605000
	ID_Branch = 1'b1;
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0001100000;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
	MEM_WriteReg = 5'b00011;
    #20000; //625000
	EX_RegWrite = 1'b0;
	EX_WriteReg = 5'b00000;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
	MEM_RegWrite = 1'b1;
    #20000; //645000
	ID_Branch = 1'b0;
	ID_Inst = 10'b0000011101;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //665000
	ID_Branch = 1'b1;
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0001100000;
	EX_WriteReg = 5'b00011;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
    #20000; //685000
	EX_RegWrite = 1'b0;
	EX_WriteReg = 5'b00000;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
	MEM_WriteReg = 5'b00011;
	MEM_RegWrite = 1'b1;
    #20000; //705000
	ID_Branch = 1'b0;
	ID_Inst = 10'b0000011101;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //725000
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0000000100;
	EX_WriteReg = 5'b00100;
    #20000; //745000
	ID_Branch = 1'b1;
	ID_Inst = 10'b0010000000;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
	MEM_WriteReg = 5'b00100;
	MEM_RegWrite = 1'b1;
    #20000; //765000
	EX_RegWrite = 1'b0;
	EX_WriteReg = 5'b00000;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
    #20000; //785000
	ID_Branch = 1'b0;
	ID_Inst = 10'b0000000011;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //805000
	EX_RegWrite = 1'b1;
	EX_WriteReg = 5'b00011;
    #20000; //825000
	ID_Branch = 1'b1;
	ID_Inst = 10'b0001100000;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
	MEM_WriteReg = 5'b00011;
	MEM_RegWrite = 1'b1;
    #20000; //845000
	EX_RegWrite = 1'b0;
	EX_WriteReg = 5'b00000;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
    #20000; //865000
	ID_Branch = 1'b0;
	ID_Inst = 10'b0000000011;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //885000
	ID_Branch = 1'b1;
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0001100000;
	EX_WriteReg = 5'b00011;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
    #20000; //905000
	EX_RegWrite = 1'b0;
	EX_WriteReg = 5'b00000;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
	MEM_WriteReg = 5'b00011;
	MEM_RegWrite = 1'b1;
    #20000; //925000
	ID_Branch = 1'b0;
	ID_Inst = 10'b0000000011;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //945000
	EX_RegWrite = 1'b1;
	EX_WriteReg = 5'b00011;
    #20000; //965000
	ID_Branch = 1'b1;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
	MEM_WriteReg = 5'b00011;
	MEM_RegWrite = 1'b1;
    #20000; //985000
	EX_RegWrite = 1'b0;
	EX_WriteReg = 5'b00000;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
    #20000; //1005000
	ID_Branch = 1'b0;
	ID_Inst = 10'b0000000000;
	EX_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //1025000
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0000011101;
	MEM_WriteReg = 5'b00011;
    #20000; //1045000
	ID_Branch = 1'b1;
	ID_Inst = 10'b0001100000;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
	MEM_RegWrite = 1'b1;
    #20000; //1065000
	EX_RegWrite = 1'b0;
	EX_WriteReg = 5'b00000;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
    #20000; //1085000
	ID_Branch = 1'b0;
	ID_Inst = 10'b0000000000;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //1105000
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0000011101;
	EX_WriteReg = 5'b00011;
    #20000; //1125000
	ID_Branch = 1'b1;
	ID_Inst = 10'b0000000011;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
	MEM_WriteReg = 5'b00011;
	MEM_RegWrite = 1'b1;
    #20000; //1145000
	EX_RegWrite = 1'b0;
	EX_WriteReg = 5'b00000;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
    #20000; //1165000
	ID_Branch = 1'b0;
	ID_Inst = 10'b0101101100;
	EX_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //1185000
	ID_JR = 1'b1;
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0110000000;
	EX_WriteReg = 5'b01100;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
	MEM_WriteReg = 5'b00011;
    #20000; //1205000
	EX_RegWrite = 1'b0;
	EX_WriteReg = 5'b00000;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
	MEM_WriteReg = 5'b01100;
	MEM_RegWrite = 1'b1;
    #20000; //1225000
	ID_JR = 1'b0;
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0000000000;
	EX_WriteReg = 5'b11111;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //1245000
	ID_JR = 1'b1;
	ID_Inst = 10'b1111100000;
	EX_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b11111;
	MEM_RegWrite = 1'b1;
    #20000; //1265000
	ID_JR = 1'b0;
	EX_RegWrite = 1'b0;
	ID_Inst = 10'b0000000000;
	MEM_WriteReg = 5'b00000;
    #20000; //1285000
	EX_RegWrite = 1'b1;
	MEM_RegWrite = 1'b0;
    #20000; //1305000
	MEM_RegWrite = 1'b1;
    #20000; //1325000
	EX_RegWrite = 1'b0;
    #20000; //1345000
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0011100111;
	MEM_RegWrite = 1'b0;
    #20000; //1365000
	ID_Inst = 10'b1110100000;
	EX_WriteReg = 5'b00111;
	MEM_RegWrite = 1'b1;
    #20000; //1385000
	ID_Inst = 10'b0000000010;
	EX_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b00111;
    #20000; //1405000
	ID_Branch = 1'b1;
	ID_Inst = 10'b0011100000;
	EX_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00000;
    #20000; //1425000
	ID_Branch = 1'b0;
	EX_RegWrite = 1'b0;
	ID_Inst = 10'b1110100000;
	EX_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b00010;
    #20000; //1445000
	EX_RegWrite = 1'b1;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //1465000
	ID_Branch = 1'b1;
	ID_Inst = 10'b0000000111;
	EX_WriteReg = 5'b00100;
	MEM_RegWrite = 1'b1;
    #20000; //1485000
	ID_Branch = 1'b0;
	EX_RegWrite = 1'b0;
	ID_Inst = 10'b0001011101;
	EX_WriteReg = 5'b00111;
	MEM_WriteReg = 5'b00100;
    #20000; //1505000
	ID_Branch = 1'b1;
	ID_Inst = 10'b0010011101;
	EX_WriteReg = 5'b11101;
	MEM_WriteReg = 5'b00111;
	MEM_RegWrite = 1'b0;
    #20000; //1525000
	ID_Branch = 1'b0;
	ID_Inst = 10'b0001011101;
	MEM_WriteReg = 5'b11101;
    #20000; //1545000
	ID_Branch = 1'b1;
	ID_Inst = 10'b1110100100;
    #20000; //1565000
	ID_Branch = 1'b0;
	ID_Inst = 10'b0000000000;
	EX_WriteReg = 5'b00100;
    #20000; //1585000
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0001000000;
	EX_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b00100;
    #20000; //1605000
	ID_Inst = 10'b0000000010;
	EX_WriteReg = 5'b00100;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b1;
    #20000; //1625000
	ID_Inst = 10'b0001000011;
	EX_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00100;
    #20000; //1645000
	ID_Inst = 10'b0001000100;
	EX_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b00010;
    #20000; //1665000
	ID_Inst = 10'b0000000010;
	EX_WriteReg = 5'b00100;
	MEM_WriteReg = 5'b00011;
    #20000; //1685000
	ID_Inst = 10'b0001011101;
	EX_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00100;
    #20000; //1705000
	MEM_WriteReg = 5'b00010;
    #20000; //1725000
	ID_Inst = 10'b0000000010;
	EX_WriteReg = 5'b00011;
    #20000; //1745000
	ID_Inst = 10'b0001000010;
	EX_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00011;
    #20000; //1765000
	ID_Inst = 10'b0001000011;
	MEM_WriteReg = 5'b00010;
    #20000; //1785000
	ID_Inst = 10'b0000000000;
	EX_WriteReg = 5'b00011;
    #20000; //1805000
	ID_Inst = 10'b0000000101;
	EX_WriteReg = 5'b00101;
	MEM_WriteReg = 5'b00011;
    #20000; //1825000
	EX_WriteReg = 5'b00110;
	MEM_WriteReg = 5'b00101;
    #20000; //1845000
	EX_WriteReg = 5'b00111;
	MEM_WriteReg = 5'b00110;
    #20000; //1865000
	ID_Inst = 10'b1110100101;
	EX_WriteReg = 5'b00101;
	MEM_WriteReg = 5'b00111;
    #20000; //1885000
	MEM_WriteReg = 5'b00101;
    #20000; //1905000
	ID_Inst = 10'b0000000101;
	EX_WriteReg = 5'b00110;
    #20000; //1925000
	ID_Inst = 10'b1110100101;
	EX_WriteReg = 5'b00101;
	MEM_WriteReg = 5'b00110;
    #20000; //1945000
	MEM_WriteReg = 5'b00101;
    #20000; //1965000
	ID_Inst = 10'b1110111101;
    #20000; //1985000
	ID_Inst = 10'b0001011101;
	EX_WriteReg = 5'b00010;
    #20000; //2005000
	ID_Inst = 10'b0001000011;
	EX_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b00010;
    #20000; //2025000
	ID_Inst = 10'b1110111101;
	EX_WriteReg = 5'b00100;
	MEM_WriteReg = 5'b00011;
    #20000; //2045000
	ID_Inst = 10'b1110100010;
	EX_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00100;
    #20000; //2065000
	ID_Inst = 10'b0001100010;
	EX_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b00010;
    #20000; //2085000
	ID_Inst = 10'b1110111101;
	EX_WriteReg = 5'b00100;
	MEM_WriteReg = 5'b00011;
    #20000; //2105000
	ID_Inst = 10'b0001000010;
	EX_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00100;
    #20000; //2125000
	MEM_WriteReg = 5'b00010;
    #20000; //2145000
	ID_Inst = 10'b0000000000;
	EX_WriteReg = 5'b00011;
    #20000; //2165000
	ID_Inst = 10'b1111111101;
	EX_WriteReg = 5'b11111;
	MEM_WriteReg = 5'b00011;
    #20000; //2185000
	ID_Inst = 10'b0010111111;
	EX_WriteReg = 5'b00101;
	MEM_WriteReg = 5'b11111;
    #20000; //2205000
	ID_JR = 1'b1;
	ID_Inst = 10'b1111100000;
	EX_WriteReg = 5'b00110;
	MEM_WriteReg = 5'b00101;
    #20000; //2225000
	ID_JR = 1'b0;
	EX_RegWrite = 1'b0;
	ID_Inst = 10'b0000000000;
	EX_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b00110;
    #20000; //2245000
	ID_JR = 1'b1;
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0100100000;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //2265000
	ID_JR = 1'b0;
	ID_Inst = 10'b1111111101;
	EX_WriteReg = 5'b11111;
	MEM_RegWrite = 1'b1;
    #20000; //2285000
	ID_Inst = 10'b0010111111;
	EX_WriteReg = 5'b00101;
	MEM_WriteReg = 5'b11111;
    #20000; //2305000
	ID_JR = 1'b1;
	ID_Inst = 10'b1111100000;
	EX_WriteReg = 5'b00110;
	MEM_WriteReg = 5'b00101;
    #20000; //2325000
	ID_JR = 1'b0;
	EX_RegWrite = 1'b0;
	ID_Inst = 10'b0000000000;
	EX_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b00110;
    #20000; //2345000
	ID_JR = 1'b1;
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0101000000;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //2365000
	ID_JR = 1'b0;
	ID_Inst = 10'b1111011101;
	EX_WriteReg = 5'b11110;
	MEM_RegWrite = 1'b1;
    #20000; //2385000
	ID_Inst = 10'b0010111110;
	EX_WriteReg = 5'b00101;
	MEM_WriteReg = 5'b11110;
    #20000; //2405000
	ID_JR = 1'b1;
	ID_Inst = 10'b1111000000;
	EX_WriteReg = 5'b00110;
	MEM_WriteReg = 5'b00101;
    #20000; //2425000
	ID_JR = 1'b0;
	EX_RegWrite = 1'b0;
	ID_Inst = 10'b0000000000;
	EX_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b00110;
    #20000; //2445000
	EX_RegWrite = 1'b1;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //2465000
	EX_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
    #20000; //2485000
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b1110111101;
	MEM_RegWrite = 1'b0;
    #20000; //2505000
	ID_Inst = 10'b0000011101;
	MEM_RegWrite = 1'b1;
    #20000; //2525000
	ID_Inst = 10'b1110111101;
	EX_WriteReg = 5'b00010;
    #20000; //2545000
	ID_Inst = 10'b0000000000;
	EX_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b00010;
    #20000; //2565000
	ID_Inst = 10'b0000011101;
	MEM_WriteReg = 5'b00000;
    #20000; //2585000
	ID_Inst = 10'b1110111101;
	EX_WriteReg = 5'b00010;
    #20000; //2605000
	ID_Inst = 10'b1110100000;
	EX_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b00010;
    #20000; //2625000
	ID_Inst = 10'b1110111101;
	EX_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00000;
    #20000; //2645000
	ID_Inst = 10'b0000001011;
	EX_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b00010;
    #20000; //2665000
	ID_Inst = 10'b0000011101;
	EX_WriteReg = 5'b01011;
	MEM_WriteReg = 5'b00000;
    #20000; //2685000
	ID_Inst = 10'b0101100011;
	EX_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b01011;
    #20000; //2705000
	EX_RegWrite = 1'b0;
	ID_Inst = 10'b0001100000;
	EX_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b00010;
    #20000; //2725000
	EX_RegWrite = 1'b1;
	EX_WriteReg = 5'b00100;
	MEM_WriteReg = 5'b00011;
	MEM_RegWrite = 1'b0;
    #20000; //2745000
	ID_Inst = 10'b0101100011;
	MEM_WriteReg = 5'b00100;
	MEM_RegWrite = 1'b1;
    #20000; //2765000
	EX_RegWrite = 1'b0;
	ID_Inst = 10'b0000000011;
	EX_WriteReg = 5'b00011;
    #20000; //2785000
	EX_RegWrite = 1'b1;
	EX_WriteReg = 5'b00100;
	MEM_WriteReg = 5'b00011;
	MEM_RegWrite = 1'b0;
    #20000; //2805000
	ID_Inst = 10'b0000001011;
	MEM_WriteReg = 5'b00100;
	MEM_RegWrite = 1'b1;
    #20000; //2825000
	ID_Inst = 10'b0110000010;
	EX_WriteReg = 5'b01100;
    #20000; //2845000
	EX_RegWrite = 1'b0;
	ID_Inst = 10'b0110000000;
	EX_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b01100;
    #20000; //2865000
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b1110111101;
	EX_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b00010;
	MEM_RegWrite = 1'b0;
    #20000; //2885000
	ID_Inst = 10'b0101100010;
	EX_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00011;
	MEM_RegWrite = 1'b1;
    #20000; //2905000
	EX_RegWrite = 1'b0;
	ID_Inst = 10'b0001000000;
	MEM_WriteReg = 5'b00010;
    #20000; //2925000
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0101101011;
	EX_WriteReg = 5'b00011;
	MEM_RegWrite = 1'b0;
    #20000; //2945000
	EX_RegWrite = 1'b0;
	EX_WriteReg = 5'b01011;
	MEM_WriteReg = 5'b00011;
	MEM_RegWrite = 1'b1;
    #20000; //2965000
	MEM_WriteReg = 5'b01011;
	MEM_RegWrite = 1'b0;
    #20000; //2985000
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0101101101;
	EX_WriteReg = 5'b01100;
    #20000; //3005000
	ID_Inst = 10'b0110100000;
	EX_Load = 1'b1;
	EX_WriteReg = 5'b01101;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
	MEM_WriteReg = 5'b01100;
	MEM_RegWrite = 1'b1;
    #20000; //3025000
	EX_RegWrite = 1'b0;
	EX_Load = 1'b0;
	MEM_Load = 1'b1;
	EX_WriteReg = 5'b00000;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
	MEM_WriteReg = 5'b01101;
    #20000; //3045000
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0101101110;
	MEM_Load = 1'b0;
	EX_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //3065000
	ID_Inst = 10'b0000001110;
	EX_Load = 1'b1;
	EX_WriteReg = 5'b01110;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
	MEM_WriteReg = 5'b00011;
	MEM_RegWrite = 1'b1;
    #20000; //3085000
	EX_RegWrite = 1'b0;
	EX_Load = 1'b0;
	MEM_Load = 1'b1;
	EX_WriteReg = 5'b00000;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
	MEM_WriteReg = 5'b01110;
    #20000; //3105000
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0101101100;
	MEM_Load = 1'b0;
	EX_WriteReg = 5'b00100;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //3125000
	ID_Inst = 10'b0110001100;
	EX_WriteReg = 5'b01100;
	MEM_WriteReg = 5'b00100;
	MEM_RegWrite = 1'b1;
    #20000; //3145000
	EX_RegWrite = 1'b0;
	MEM_WriteReg = 5'b01100;
    #20000; //3165000
	EX_RegWrite = 1'b1;
	EX_Load = 1'b1;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
	MEM_RegWrite = 1'b0;
    #20000; //3185000
	EX_RegWrite = 1'b0;
	EX_Load = 1'b0;
	MEM_Load = 1'b1;
	EX_WriteReg = 5'b00000;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
	MEM_RegWrite = 1'b1;
    #20000; //3205000
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0101100000;
	EX_Load = 1'b1;
	MEM_Load = 1'b0;
	EX_WriteReg = 5'b01100;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //3225000
	EX_RegWrite = 1'b0;
	EX_Load = 1'b0;
	MEM_Load = 1'b1;
	EX_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b01100;
	MEM_RegWrite = 1'b1;
    #20000; //3245000
	MEM_Load = 1'b0;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //3265000
	ID_Inst = 10'b0101110000;
    #20000; //3285000
	ID_Branch = 1'b1;
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0000010000;
	EX_Load = 1'b1;
	EX_WriteReg = 5'b10000;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
    #20000; //3305000
	EX_RegWrite = 1'b0;
	EX_Load = 1'b0;
	MEM_Load = 1'b1;
	EX_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b10000;
	MEM_RegWrite = 1'b1;
    #20000; //3325000
	MEM_Load = 1'b0;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //3345000
	ID_Branch = 1'b0;
	ID_Inst = 10'b0101110001;
	EX_WriteReg = 5'b10000;
    #20000; //3365000
	ID_Branch = 1'b1;
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b1000110000;
	EX_Load = 1'b1;
	EX_WriteReg = 5'b10001;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
	MEM_WriteReg = 5'b10000;
    #20000; //3385000
	EX_RegWrite = 1'b0;
	EX_Load = 1'b0;
	MEM_Load = 1'b1;
	EX_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b10001;
	MEM_RegWrite = 1'b1;
    #20000; //3405000
	MEM_Load = 1'b0;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //3425000
	ID_Branch = 1'b0;
	ID_Inst = 10'b0101110010;
	EX_WriteReg = 5'b10000;
    #20000; //3445000
	ID_Branch = 1'b1;
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b1001010001;
	EX_Load = 1'b1;
	EX_WriteReg = 5'b10010;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
	MEM_WriteReg = 5'b10000;
    #20000; //3465000
	EX_RegWrite = 1'b0;
	EX_Load = 1'b0;
	MEM_Load = 1'b1;
	EX_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b10010;
	MEM_RegWrite = 1'b1;
    #20000; //3485000
	MEM_Load = 1'b0;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //3505000
	ID_Branch = 1'b0;
	ID_Inst = 10'b0000000000;
	EX_WriteReg = 5'b10001;
    #20000; //3525000
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0101110000;
	EX_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b10001;
    #20000; //3545000
	ID_Inst = 10'b0101101011;
	EX_Load = 1'b1;
	EX_WriteReg = 5'b10000;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b1;
    #20000; //3565000
	ID_Branch = 1'b1;
	ID_Inst = 10'b1000000000;
	EX_Load = 1'b0;
	MEM_Load = 1'b1;
	EX_WriteReg = 5'b01011;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
	MEM_WriteReg = 5'b10000;
    #20000; //3585000
	EX_RegWrite = 1'b0;
	MEM_Load = 1'b0;
	EX_WriteReg = 5'b00000;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
	MEM_WriteReg = 5'b01011;
    #20000; //3605000
	ID_Branch = 1'b0;
	ID_Inst = 10'b0101110001;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //3625000
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0101101011;
	EX_Load = 1'b1;
	EX_WriteReg = 5'b10001;
    #20000; //3645000
	ID_Branch = 1'b1;
	ID_Inst = 10'b1000010001;
	EX_Load = 1'b0;
	MEM_Load = 1'b1;
	EX_WriteReg = 5'b01011;
	IDEXReg_Clear = 1'b1;
	LoadEnable = 1'b0;
	MEM_WriteReg = 5'b10001;
	MEM_RegWrite = 1'b1;
    #20000; //3665000
	EX_RegWrite = 1'b0;
	MEM_Load = 1'b0;
	EX_WriteReg = 5'b00000;
	IDEXReg_Clear = 1'b0;
	LoadEnable = 1'b1;
	MEM_WriteReg = 5'b01011;
    #20000; //3685000
	ID_Branch = 1'b0;
	ID_Inst = 10'b0101110010;
	EX_WriteReg = 5'b10001;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
    #20000; //3705000
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0101101011;
	EX_Load = 1'b1;
	EX_WriteReg = 5'b10010;
	MEM_WriteReg = 5'b10001;
    #20000; //3725000
	ID_Inst = 10'b0000011100;
	EX_Load = 1'b0;
	MEM_Load = 1'b1;
	EX_WriteReg = 5'b01011;
	MEM_WriteReg = 5'b10010;
	MEM_RegWrite = 1'b1;
    #20000; //3745000
	ID_Branch = 1'b1;
	ID_Inst = 10'b1000110010;
	MEM_Load = 1'b0;
	EX_WriteReg = 5'b11100;
	MEM_WriteReg = 5'b01011;
    #20000; //3765000
	ID_Branch = 1'b0;
	EX_RegWrite = 1'b0;
	ID_Inst = 10'b1110111101;
	EX_WriteReg = 5'b10010;
	MEM_WriteReg = 5'b11100;
    #20000; //3785000
	EX_RegWrite = 1'b1;
	ID_Inst = 10'b0000011100;
	EX_WriteReg = 5'b11101;
	MEM_WriteReg = 5'b10010;
	MEM_RegWrite = 1'b0;
    #20000; //3805000
	ID_Inst = 10'b0000000000;
	EX_WriteReg = 5'b11100;
	MEM_WriteReg = 5'b11101;
	MEM_RegWrite = 1'b1;
    #20000; //3825000
	EX_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b11100;
    #20000; //3845000
	MEM_WriteReg = 5'b00000;
    #39000; //3865000
end // end of stimulus process
	



//Set of always bloks for ports monitoring.
//One block per output port.
//Always block for monitoring port "IDEXReg_Clear";
always @(IDEXReg_Clear or IDEXReg_Clear_actual)
	begin
		#IDEXReg_Clear_WaitTime
		if (compare_IDEXReg_Clear(IDEXReg_Clear,IDEXReg_Clear_actual))
		begin
			errors_counter = errors_counter + 1;
			$fdisplay(report_file,$realtime,,"ps; Port IDEXReg_Clear: Expected value is %b, Actual value is %b",IDEXReg_Clear,IDEXReg_Clear_actual);
			$display($realtime,,"ps; Error on port IDEXReg_Clear: Expected value is %b, Actual value is %b",IDEXReg_Clear,IDEXReg_Clear_actual);
		end
	end
//Always block for monitoring port "LoadEnable";
always @(LoadEnable or LoadEnable_actual)
	begin
		#LoadEnable_WaitTime
		if (compare_LoadEnable(LoadEnable,LoadEnable_actual))
		begin
			errors_counter = errors_counter + 1;
			$fdisplay(report_file,$realtime,,"ps; Port LoadEnable: Expected value is %b, Actual value is %b",LoadEnable,LoadEnable_actual);
			$display($realtime,,"ps; Error on port LoadEnable: Expected value is %b, Actual value is %b",LoadEnable,LoadEnable_actual);
		end
	end

endmodule
